/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.data;
//本类继承于Task，主要用于记录数据的变化

import android.database.Cursor;//基于数据库服务的类
import android.util.Log;//日志工具类，提供了5个方法来供我们打印日志

import net.micode.notes.tool.GTaskStringUtils;//导入tool包中GTaskStringUtils类的方法

import org.json.JSONException;//Json使用失败异常处理
import org.json.JSONObject;//存储json对象的属性名和属性值


public class MetaData extends Task {
    private final static String TAG = MetaData.class.getSimpleName();
//调用getSimpleName()函数来得到类的简写名称存入字符串TAG中
    private String mRelatedGid = null;//初始化mRelatedGid的值

    public void setMeta(String gid, JSONObject metaInfo) {
        try {
            metaInfo.put(GTaskStringUtils.META_HEAD_GTASK_ID, gid);//将这对键值放入metaInfo这个jsonobject对象中
        } catch (JSONException e) {
            Log.e(TAG, "failed to put related gid");
        }//捕捉异常，输出错误信息
        setNotes(metaInfo.toString());//设置便签，将Json类的metaInfo转为string
        setName(GTaskStringUtils.META_NOTE_NAME);//设置gtask的名字
    }//设置数据，生成元数据库

    public String getRelatedGid() {
        return mRelatedGid;
    }//获取相关联的Gid

    @Override
    public boolean isWorthSaving() {
        return getNotes() != null;
    }//判断当前数据是否有效，若数据非空则返回真值

    @Override
    public void setContentByRemoteJSON(JSONObject js) {
        super.setContentByRemoteJSON(js);//调用父类Task中的setContentByRemoteJSON()函数
        if (getNotes() != null) {	//如果数据非空，获取jsono metainfo和相关gid
            try {
                JSONObject metaInfo = new JSONObject(getNotes().trim());
                mRelatedGid = metaInfo.getString(GTaskStringUtils.META_HEAD_GTASK_ID);
            } catch (JSONException e) {
                Log.w(TAG, "failed to get related gid");
                mRelatedGid = null;
            }
        }
    }//调用父类Task中的setContentByRemoteJSON()函数，使用远程json数据对象设置元数据内容

    @Override
    public void setContentByLocalJSON(JSONObject js) {
        // this function should not be called
        throw new IllegalAccessError("MetaData:setContentByLocalJSON should not be called");
    }//使用本地json数据对象设置元数据内容，一般不会用到，若用到，则抛出异常

    @Override
    public JSONObject getLocalJSONFromContent() {
        throw new IllegalAccessError("MetaData:getLocalJSONFromContent should not be called");
    }//从元数据内容中获取本地json对象

    @Override
    public int getSyncAction(Cursor c) {
        throw new IllegalAccessError("MetaData:getSyncAction should not be called");
    }//获取同步动作状态，一般不会用到，若用到，则抛出异常

}//创建一个继承Task的类MataData
